;*****************************************************************
;   ().  
;  ATtiny12.  .. 9  2008.
;*****************************************************************
.Include "tn12def.inc"
.ORG 000        ;Reset vector.
rjmp reset
.ORG 0x003      ;     0.
in r4, sreg
inc r20         ;  1   R20.
sbrc r20,0      ;    R20 ,
rjmp pause      ; ,
sbrs r20,0      ; ,
rjmp imp        ; .
pause:
cbi portb,0     ;.0   0 ().
out tcnt0,r18   ;  -0  .
rjmp ss         ;    .
imp:
sbi portb,0     ;.1   0 ().
out tcnt0,r19   ;  -0  .
out sreg,r4
ss: reti        ;  .
reset:
sbi ddrb,0      ; 0 - .
ldi r16,14      
out portb,r16   ;""    1-3.
ldi r16,2
out tccr0,r16   ;  -0- .
out timsk,r16   ;   -.
ldi r18,150     ;  R18  .
ldi r19,105     ;  R19  .
start:
out tcnt0,r19
sei             ;  .
scan:
sbis pinb,1     ;,    "+".
rjmp plus       ;  -    "plus".
sbis pinb,2     ;,    "-".
rjmp min        ;  -    "min".
sbis pinb,3     ;,    "STANDBY"
rjmp a1         ;  -    1.
rjmp scan       ;    ,    "scan".
a1:
mov r1,r18      ;  R1   .
mov r2,r19      ;  R2   .
a2:
ldi r18,150     ;      
ldi r19,105     ; ,  60% .
sbis pinb,3     ;,    "STANDBY",
rjmp a2         ; ,  60% .
mov r18,r1      ; ,    R18,R19 ,
mov r19,r2      ;   R1,R2   SF1.
rjmp scan
plus:
cpi r18,241     ;  ,
brsh scan       ;   "scan".
ldi r25,15      ;:
add r18,r25     ;  
sub r19,r25     ; .
rjmp pause2     ;  ""   "+".
min:
cpi r19,241     ;  ,
brsh scan       ;   "scan".
ldi r25,15      ;:
add r19,r25     ;  
sub r18,r25     ; .
rjmp pause2     ;  ""   "-".  
;******************************************************************
pause2:
 ldi r24,5
m1: ser r22
m2: ser r23
m3: dec r23
brne m3
dec r22
brne m2
dec r24
brne m1
rjmp scan
